<?php
//echo "node id = " . $_GET['node'];
chdir('../../');
include("./include/global.php");
include_once("./lib/utility.php");
include_once("./lib/api_data_source.php");
include_once("./lib/api_tree.php");
include_once("./lib/html_tree.php");
include_once("./lib/api_graph.php");
include_once("./lib/snmp.php");
include_once("./lib/ping.php");
include_once("./lib/data_query.php");
include_once("./lib/api_device.php");


if (!empty($_GET["node"])) 
{
    $host = db_fetch_row("select * from host where id=" . $_GET["node"]);
}        
//    $host = db_fetch_row("select * from host where id=2");

if ((($host["snmp_community"] == "") && ($host["snmp_username"] == "")) || ($host["snmp_version"] == 0)) 
{
    print "<span style='color: #ab3f1e; font-weight: bold;'>SNMP not in use</span>\n";
}
else
{
    $snmp_system = cacti_snmp_get($host["hostname"], $host["snmp_community"], ".1.3.6.1.2.1.1.1.0", $host["snmp_version"],
				  $host["snmp_username"], $host["snmp_password"],
                                  $host["snmp_auth_protocol"], $host["snmp_priv_passphrase"], $host["snmp_priv_protocol"],
                                  $host["snmp_context"], $host["snmp_port"], $host["snmp_timeout"], read_config_option("snmp_retries"),SNMP_WEBUI);
                                  
    /* modify for some system descriptions */
    /* 0000937: System output in hosts.php poor for Alcatel */
    if (substr_count($snmp_system, "00:")) 
    {
        $snmp_system = str_replace("00:", "", $snmp_system);
        $snmp_system = str_replace(":", " ", $snmp_system);
    }

    if ($snmp_system == "") 
    {
        print "<span style='color: #ff0000; font-weight: bold;'>SNMP error</span>\n";
    }
    else
    {
	$snmp_version = cacti_snmp_get($host["hostname"], $host["snmp_community"], ".1.3.6.1.2.1.16.19.6.0", $host["snmp_version"],
                                                   $host["snmp_username"], $host["snmp_password"],
                                                   $host["snmp_auth_protocol"], $host["snmp_priv_passphrase"], $host["snmp_priv_protocol"],
                                                   $host["snmp_context"], $host["snmp_port"], $host["snmp_timeout"], read_config_option("snmp_retries"), SNMP_WEBUI);


	$snmp_hardware = cacti_snmp_get($host["hostname"], $host["snmp_community"], ".1.3.6.1.2.1.47.1.1.1.1.7.1", $host["snmp_version"],
                                                   $host["snmp_username"], $host["snmp_password"],
                                                   $host["snmp_auth_protocol"], $host["snmp_priv_passphrase"], $host["snmp_priv_protocol"],
                                                   $host["snmp_context"], $host["snmp_port"], $host["snmp_timeout"], read_config_option("snmp_retries"), SNMP_WEBUI);


        $snmp_uptime   = cacti_snmp_get($host["hostname"], $host["snmp_community"], ".1.3.6.1.2.1.1.3.0", $host["snmp_version"],
        				$host["snmp_username"], $host["snmp_password"],
                                        $host["snmp_auth_protocol"], $host["snmp_priv_passphrase"], $host["snmp_priv_protocol"],
                                        $host["snmp_context"], $host["snmp_port"], $host["snmp_timeout"], read_config_option("snmp_retries"), SNMP_WEBUI);

        $snmp_hostname = cacti_snmp_get($host["hostname"], $host["snmp_community"], ".1.3.6.1.2.1.1.5.0", $host["snmp_version"],
                                                            $host["snmp_username"], $host["snmp_password"],
                                                            $host["snmp_auth_protocol"], $host["snmp_priv_passphrase"], $host["snmp_priv_protocol"],
                                                            $host["snmp_context"], $host["snmp_port"], $host["snmp_timeout"], read_config_option("snmp_retries"), SNMP_WEBUI);

        $snmp_location = cacti_snmp_get($host["hostname"], $host["snmp_community"], ".1.3.6.1.2.1.1.6.0", $host["snmp_version"],
                                                            $host["snmp_username"], $host["snmp_password"],
                                                            $host["snmp_auth_protocol"], $host["snmp_priv_passphrase"], $host["snmp_priv_protocol"],
                                                            $host["snmp_context"], $host["snmp_port"], $host["snmp_timeout"], read_config_option("snmp_retries"), SNMP_WEBUI);

        $snmp_contact  = cacti_snmp_get($host["hostname"], $host["snmp_community"], ".1.3.6.1.2.1.1.4.0", $host["snmp_version"],
                                                            $host["snmp_username"], $host["snmp_password"],
                                                            $host["snmp_auth_protocol"], $host["snmp_priv_passphrase"], $host["snmp_priv_protocol"],
                                                            $host["snmp_context"], $host["snmp_port"], $host["snmp_timeout"], read_config_option("snmp_retries"), SNMP_WEBUI);

	$snmp_cpu 	= cacti_snmp_get($host["hostname"], $host["snmp_community"], ".1.3.6.1.4.1.9.2.1.58.0", $host["snmp_version"],
                                           $host["snmp_username"], $host["snmp_password"],
                                           $host["snmp_auth_protocol"], $host["snmp_priv_passphrase"], $host["snmp_priv_protocol"],
                                           $host["snmp_context"], $host["snmp_port"], $host["snmp_timeout"], read_config_option("snmp_retries"), SNMP_WEBUI);

	$snmp_dhcpbind =  cacti_snmp_walk($host["hostname"], $host["snmp_community"], "1.3.6.1.4.1.9.9.380.1.4.1.1.4", $host["snmp_version"],
                                        $host["snmp_username"], $host["snmp_password"],
                                        $host["snmp_auth_protocol"], $host["snmp_priv_passphrase"], $host["snmp_priv_protocol"],
                                        $host["snmp_context"], $host["snmp_port"], $host["snmp_timeout"], read_config_option("snmp_retries"), SNMP_WEBUI);

	$num_bind = count($snmp_dhcpbind);	


	$snmp_dot1x = cacti_snmp_walk($host["hostname"], $host["snmp_community"], "iso.0.8802.1.1.1.1.2.1.1.1", $host["snmp_version"],
                                        $host["snmp_username"], $host["snmp_password"],
                                        $host["snmp_auth_protocol"], $host["snmp_priv_passphrase"], $host["snmp_priv_protocol"],
                                        $host["snmp_context"], $host["snmp_port"], $host["snmp_timeout"], read_config_option("snmp_retries"), SNMP_WEBUI);
	$count = 0;
	foreach($snmp_dot1x as $key) { foreach($key as $value){if($value == 5) { $count++; } }} ; 
	$dot1x_auth = $count;
	
	$snmp_ifstatus = cacti_snmp_walk($host["hostname"], $host["snmp_community"], "1.3.6.1.2.1.2.2.1.8", $host["snmp_version"],
                                        $host["snmp_username"], $host["snmp_password"],
                                        $host["snmp_auth_protocol"], $host["snmp_priv_passphrase"], $host["snmp_priv_protocol"],
                                        $host["snmp_context"], $host["snmp_port"], $host["snmp_timeout"], read_config_option("snmp_retries"), SNMP_WEBUI);
       
	$interfaces = count($snmp_ifstatus);
	$count = 0;
        foreach($snmp_ifstatus as $key) { foreach($key as $value){if($value == 'up(1)') { $count++; } }} ;
        $ifstatus_up  = $count;
	$count = 0;
	foreach($snmp_ifstatus as $key) { foreach($key as $value){if($value == 'down(2)') { $count++; } }} ;
        $ifstatus_down  = $count;		

	print "<table>";
	print "<tr bgcolor='999999'><td style='font-size:65%;text-align:center;' colspan='3'><strong>Info</strong></td></tr>";
        print "<tr bgcolor='E2E2E2'><td style='font-size:60%'><strong>System_Name:</strong></td><td style='font-size:60%' colspan='2'>" . $host["description"] . "</td></tr>\n";
        print "<tr><td style='font-size:60%'><strong>System IP:</strong></td><td style='font-size:60%' colspan='2'>" . $host["hostname"] . "</td></tr>\n";
        print "<tr bgcolor='E2E2E2'><td style='font-size:60%'><strong>Availability:</strong></td><td style='font-size:60%' colspan='2'>" . round($host["availability"],2) . "%</td></tr>\n";
        print "<tr><td valign='top' style='font-size:60%'0><strong>System:</strong></td><td style='font-size:60%' colspan='2'>" . html_split_string($snmp_system) . "</td></tr>\n";
        print "<tr bgcolor='E2E2E2'><td valign='top' style='font-size:60%'0><strong>Version:</strong></td><td style='font-size:60%' colspan='2'> $snmp_version </td></tr>";
	 $days      = intval($snmp_uptime / (60*60*24*100));
        $remainder = $snmp_uptime % (60*60*24*100);
        $hours     = intval($remainder / (60*60*100));
        $remainder = $remainder % (60*60*100);
        $minutes   = intval($remainder / (60*100));
        print "<tr ><td style='font-size:60%'><strong>Uptime:</strong></td><td style='font-size:60%' colspan='2'> $snmp_uptime";
        print "&nbsp;($days days, $hours hours, $minutes minutes)</td></tr>\n";
        print "<tr bgcolor='E2E2E2'><td style='font-size:60%'><strong>Hostname:</strong></td><td style='font-size:60%' colspan='2'> $snmp_hostname</td></tr>\n";
        print "<tr ><td style='font-size:60%'><strong>Location:</strong></td><td style='font-size:60%' colspan='2'> $snmp_location</td></tr>\n";
        print "<tr bgcolor='E2E2E2'><td style='font-size:60%'><strong>Contact:</strong></td><td style='font-size:60%' colspan='2'> $snmp_contact</td></tr>\n";
	print "<tr ><td style='font-size:60%'><strong>Hardware:</strong></td><td style='font-size:60%' colspan='2'> $snmp_hardware</td></tr>\n";
       	print "<tr bgcolor='999999'><td style='font-size:65%;text-align:center;' colspan='3'><strong>Stats</strong></td></tr>";
	print "<tr bgcolor='E2E2E2'><td style='font-size:60%'><strong>5Min CPU </strong>".$snmp_cpu."%</td>";
	print "<td style='font-size:60%'><strong>DHCP Bindings:</strong> $num_bind </td>";
	print "<td style='font-size:60%'><strong>Auth Users:</strong> $dot1x_auth </td></tr>\n";
	print "<tr><td style='font-size:60%'><strong>Interfaces</strong> $interfaces </td>";
        print "<td style='font-size:60%'><strong>Up</strong> $ifstatus_up </td>";
        print "<td style='font-size:60%'><strong>Down</strong> $ifstatus_down </td></tr>\n";
	print "</table>";
		    }
}
?>										
